## sdformat12 12.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0004 NEW)
endif(COMMAND CMAKE_POLICY)

project (sdformat12 VERSION 12.5.0)

# The protocol version has nothing to do with the package version.
# It represents the current version of SDFormat implemented by the software
set (SDF_PROTOCOL_VERSION 1.9)

OPTION(SDFORMAT_DISABLE_CONSOLE_LOGFILE "Disable the sdformat console logfile" OFF)

# BUILD_SDF is preserved for backwards compatibility but can be removed on the main branch
set (BUILD_SDF ON CACHE INTERNAL "Build SDF" FORCE)

#################################################
# Find ign-cmake
find_package(ignition-cmake2 2.10 REQUIRED)
set(IGN_CMAKE_VER ${ignition-cmake2_VERSION_MAJOR})

if (BUILD_SDF)
  ign_configure_project(
    NO_IGNITION_PREFIX
    REPLACE_IGNITION_INCLUDE_PATH sdf
    VERSION_SUFFIX)

  #################################################
  # Find tinyxml2.
  ign_find_package(TINYXML2 REQUIRED)

  ################################################
  # Find urdfdom parser. Logic:
  #
  #  1. if USE_INTERNAL_URDF is unset, try to use system installation, fallback to internal copy
  #  2. if USE_INTERNAL_URDF is set to True, use the internal copy
  #  3. if USE_INTERNAL_URDF is set to False, force to search system installation, fail on error
  if (NOT DEFINED USE_INTERNAL_URDF OR NOT USE_INTERNAL_URDF)
    ign_find_package(IgnURDFDOM VERSION 1.0 QUIET)
    if (NOT IgnURDFDOM_FOUND)
      if (NOT DEFINED USE_INTERNAL_URDF)
        # fallback to internal urdf
        set(USE_INTERNAL_URDF ON)
      else()
        ign_build_error("Couldn't find the urdfdom >= 1.0 system installation")
      endif()
    endif()
  endif()

  if (USE_INTERNAL_URDF)
    message(STATUS "Using internal URDF")
  endif()

  #################################################
  # Find ign command line utility:
  find_program(IGN_PROGRAM ign)

  #################################################
  # Copied from catkin/cmake/empy.cmake
  include(IgnPython)
  function(find_python_module module)
    # cribbed from http://www.cmake.org/pipermail/cmake/2011-January/041666.html
    string(TOUPPER ${module} module_upper)
    if(NOT PY_${module_upper})
      if(ARGC GREATER 1 AND ARGV1 STREQUAL "REQUIRED")
        set(${module}_FIND_REQUIRED TRUE)
      endif()
      # A module's location is usually a directory, but for
      # binary modules
      # it's a .so file.
      execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "import re, ${module}; print(re.compile('/__init__.py.*').sub('',${module}.__file__))"
        RESULT_VARIABLE _${module}_status
        OUTPUT_VARIABLE _${module}_location
        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
      if(NOT _${module}_status)
        set(PY_${module_upper} ${_${module}_location} CACHE STRING "Location of Python module ${module}")
      endif(NOT _${module}_status)
    endif(NOT PY_${module_upper})
    include(FindPackageHandleStandardArgs)
    find_package_handle_standard_args(PY_${module} DEFAULT_MSG PY_${module_upper})
  endfunction(find_python_module)

  ################################################
  # Find psutil python package for memory tests
  find_python_module(psutil)
  if (NOT PY_PSUTIL)
    ign_build_warning("Python psutil package not found. Memory leak tests will be skipped")
  endif()

  ################################################
  # Find ruby executable to produce xml schemas
  find_program(RUBY ruby)
  if (NOT RUBY)
    ign_build_error ("Ruby version 1.9 is needed to build xml schemas")
  else()
    message(STATUS "Found ruby executable: ${RUBY}")
  endif()

  ########################################
  # Find ignition math
  # Set a variable for generating ProjectConfig.cmake
  ign_find_package(ignition-math6 VERSION 6.8 REQUIRED)
  set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

  ########################################
  # Find ignition utils
  ign_find_package(ignition-utils1 VERSION REQUIRED)
  ign_find_package(ignition-utils1 COMPONENTS cli REQUIRED_BY usd)
  set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})

  ########################################
  # Find ignition common
  ign_find_package(ignition-common4 COMPONENTS graphics REQUIRED_BY usd)
  set(IGN_COMMON_VER ${ignition-common4_VERSION_MAJOR})

  ########################################
  # Find PXR
  ign_find_package(pxr QUIET REQUIRED_BY usd PKGCONFIG pxr)

  ign_configure_build(HIDE_SYMBOLS_BY_DEFAULT QUIT_IF_BUILD_ERRORS
    COMPONENTS usd)

  ign_create_packages()

  add_subdirectory(sdf)
  add_subdirectory(conf)
  add_subdirectory(doc)
endif(BUILD_SDF)

########################################
# Setup Codecheck

# Ignore vendored directories.
file(WRITE ${PROJECT_BINARY_DIR}/cppcheck.suppress
  "*:${PROJECT_SOURCE_DIR}/src/urdf/*\n"
  )

########################################
# Configure documentation uploader
configure_file("${CMAKE_SOURCE_DIR}/cmake/upload_doc.sh.in"
  ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

message(STATUS "Configuration successful. Type make to compile sdf")

=== src/CMakeLists.txt ===
# Collect source files into the "sources" variable and unit test files into the
# "gtest_sources" variable
ign_get_libsources_and_unittests(sources gtest_sources)

# Add the source file auto-generated into the build folder from sdf/CMakeLists.txt
list(APPEND sources EmbeddedSdf.cc)

# Use interface library to deduplicate cmake logic for URDF linking
add_library(using_parser_urdf INTERFACE)
if (USE_INTERNAL_URDF)
  set(sources ${sources}
    urdf/urdf_parser/model.cpp
    urdf/urdf_parser/link.cpp
    urdf/urdf_parser/joint.cpp
    urdf/urdf_parser/pose.cpp
    urdf/urdf_parser/twist.cpp
    urdf/urdf_parser/urdf_model_state.cpp
    urdf/urdf_parser/urdf_sensor.cpp
    urdf/urdf_parser/world.cpp)
  target_include_directories(using_parser_urdf INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/urdf)
  if (WIN32)
    target_compile_definitions(using_parser_urdf INTERFACE -D_USE_MATH_DEFINES)
  endif()
else()
  target_link_libraries(using_parser_urdf INTERFACE
    IgnURDFDOM::IgnURDFDOM)
endif()

if (BUILD_TESTING)
  # Build this test file only if Ignition Tools is installed.
  if (NOT IGN_PROGRAM)
    list(REMOVE_ITEM gtest_sources ign_TEST.cc)
  endif()

  # Skip tests that don't work on Windows
  if (WIN32)
    list(REMOVE_ITEM gtest_sources Converter_TEST.cc)
    list(REMOVE_ITEM gtest_sources FrameSemantics_TEST.cc)
    list(REMOVE_ITEM gtest_sources ParamPassing_TEST.cc)
    list(REMOVE_ITEM gtest_sources Utils_TEST.cc)
    list(REMOVE_ITEM gtest_sources XmlUtils_TEST.cc)
    list(REMOVE_ITEM gtest_sources parser_urdf_TEST.cc)
  endif()

  ign_build_tests(
    TYPE UNIT
    SOURCES ${gtest_sources}
    INCLUDE_DIRS
      ${CMAKE_CURRENT_SOURCE_DIR}
      ${PROJECT_SOURCE_DIR}/test
  )

  if (TARGET UNIT_Converter_TEST)
    target_link_libraries(UNIT_Converter_TEST
      TINYXML2::TINYXML2)
    target_sources(UNIT_Converter_TEST PRIVATE
      Converter.cc
      EmbeddedSdf.cc
      XmlUtils.cc)
  endif()

  if (TARGET UNIT_FrameSemantics_TEST)
    target_sources(UNIT_FrameSemantics_TEST PRIVATE FrameSemantics.cc Utils.cc)
    target_link_libraries(UNIT_FrameSemantics_TEST TINYXML2::TINYXML2)
  endif()

  if (TARGET UNIT_ParamPassing_TEST)
    target_link_libraries(UNIT_ParamPassing_TEST
      TINYXML2::TINYXML2
      using_parser_urdf)
    target_sources(UNIT_ParamPassing_TEST PRIVATE
      Converter.cc
      EmbeddedSdf.cc
      FrameSemantics.cc
      ParamPassing.cc
      SDFExtension.cc
      Utils.cc
      XmlUtils.cc
      parser.cc
      parser_urdf.cc)
  endif()

  if (TARGET UNIT_Utils_TEST)
    target_sources(UNIT_Utils_TEST PRIVATE Utils.cc)
    target_link_libraries(UNIT_Utils_TEST TINYXML2::TINYXML2)
  endif()

  if (TARGET UNIT_XmlUtils_TEST)
    target_link_libraries(UNIT_XmlUtils_TEST
      TINYXML2::TINYXML2)
    target_sources(UNIT_XmlUtils_TEST PRIVATE XmlUtils.cc)
  endif()

  if (TARGET UNIT_parser_urdf_TEST)
    target_link_libraries(UNIT_parser_urdf_TEST
      TINYXML2::TINYXML2
      using_parser_urdf)
    target_sources(UNIT_parser_urdf_TEST PRIVATE
      SDFExtension.cc
      XmlUtils.cc
      parser_urdf.cc)
  endif()
endif()

ign_create_core_library(SOURCES ${sources}
  CXX_STANDARD 17
  LEGACY_PROJECT_PREFIX SDFormat
  )

target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER}
    ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
  PRIVATE
    TINYXML2::TINYXML2
    using_parser_urdf)

if (WIN32)
  target_compile_definitions(${PROJECT_LIBRARY_TARGET_NAME} PRIVATE URDFDOM_STATIC)
endif()

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}/..>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

if(NOT WIN32)
  add_subdirectory(cmd)
endif()

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  actor_dom.cc
  audio.cc
  category_bitmask.cc
  cfm_damping_implicit_spring_damper.cc
  collision_dom.cc
  converter.cc
  default_elements.cc
  deprecated_specs.cc
  disable_fixed_joint_reduction.cc
  element_tracing.cc
  fixed_joint_reduction.cc
  force_torque_sensor.cc
  frame.cc
  geometry_dom.cc
  gui_dom.cc
  include.cc
  includes.cc
  interface_api.cc
  joint_axis_frame.cc
  joint_axis_dom.cc
  joint_dom.cc
  light_dom.cc
  link_dom.cc
  link_light.cc
  locale_fix.cc
  locale_fix_cxx.cc
  material_pbr.cc
  material.cc
  model_dom.cc
  model_versions.cc
  nested_model.cc
  nested_multiple_elements_error.cc
  param_passing.cc
  parser_error_detection.cc
  parser_config.cc
  particle_emitter_dom.cc
  plugin_attribute.cc
  plugin_bool.cc
  plugin_include.cc
  pose_1_9_sdf.cc
  print_config.cc
  provide_feedback.cc
  root_dom.cc
  scene_dom.cc
  sdf_basic.cc
  sdf_custom.cc
  sdf_dom_conversion.cc
  sensor_dom.cc
  surface_dom.cc
  unknown.cc
  urdf_gazebo_extensions.cc
  urdf_joint_parameters.cc
  visual_dom.cc
  whitespace.cc
  world_dom.cc
)

if (PYTHONINTERP_FOUND AND PY_PSUTIL)
  set(tests ${tests} element_memory_leak.cc)
endif()

find_program(XMLLINT_EXE xmllint)
if (EXISTS ${XMLLINT_EXE})
  set (tests ${tests} schema_test.cc)
else()
  ign_build_warning("xmllint not found. schema_test won't be run")
endif()

ign_build_tests(TYPE ${TEST_TYPE} SOURCES ${tests} INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/test)

if (EXISTS ${XMLLINT_EXE})
  # Need to run schema target (build .xsd files) before running schema_test
  add_dependencies(${TEST_TYPE}_schema_test schema)
endif()

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash $<TARGET_FILE:${PROJECT_NAME}>)
endif()

=== usd/src/CMakeLists.txt ===
set(sources
  Conversions.cc
  UsdError.cc
  sdf_parser/Collision.cc
  sdf_parser/Geometry.cc
  sdf_parser/Joint.cc
  sdf_parser/Light.cc
  sdf_parser/Link.cc
  sdf_parser/Material.cc
  sdf_parser/Model.cc
  sdf_parser/Sensor.cc
  sdf_parser/Visual.cc
  sdf_parser/World.cc
  usd_parser/Parser.cc
  usd_parser/polygon_helper.cc
  usd_parser/USD2SDF.cc
  usd_parser/USDData.cc
  usd_parser/USDJoints.cc
  usd_parser/USDLights.cc
  usd_parser/USDLinks.cc
  usd_parser/USDMaterial.cc
  usd_parser/USDPhysics.cc
  usd_parser/USDSensors.cc
  usd_parser/USDStage.cc
  usd_parser/USDTransforms.cc
  usd_parser/USDWorld.cc
)

ign_add_component(usd SOURCES ${sources} GET_TARGET_NAME usd_target)

target_include_directories(${usd_target}
  PUBLIC
    ${PXR_INCLUDE_DIRS}
)

target_link_libraries(${usd_target}
  PUBLIC
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-common${IGN_COMMON_VER}::graphics
    ${PXR_LIBRARIES}
)

set(gtest_sources
  sdf_parser/sdf2usd_TEST.cc
  usd_parser/usd2sdf_TEST.cc
  sdf_parser/Geometry_Sdf2Usd_TEST.cc
  sdf_parser/Joint_Sdf2Usd_TEST.cc
  sdf_parser/Light_Sdf2Usd_TEST.cc
  sdf_parser/Link_Sdf2Usd_TEST.cc
  sdf_parser/Material_Sdf2Usd_TEST.cc
  sdf_parser/Sensors_Sdf2Usd_TEST.cc
  sdf_parser/Visual_Sdf2Usd_TEST.cc
  sdf_parser/World_Sdf2Usd_TEST.cc
  usd_parser/USDData_TEST.cc
  usd_parser/USDPhysics_TEST.cc
  usd_parser/USDJoints_TEST.cc
  usd_parser/USDLinks_TEST.cc
  usd_parser/USDLight_TEST.cc
  usd_parser/USDSensors_TEST.cc
  usd_parser/USDStage_TEST.cc
  usd_parser/USDTransforms_TEST.cc
  Conversions_TEST.cc
  UsdError_TEST.cc
  UsdUtils_TEST.cc
)

# Build the unit tests
ign_build_tests(
  TYPE UNIT
  SOURCES ${gtest_sources}
  LIB_DEPS ${usd_target}
  INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/test usd_parser
)

if (TARGET UNIT_USDLinks_TEST)
  target_sources(UNIT_USDLinks_TEST PRIVATE
    usd_parser/USDLinks.cc
    Conversions.cc
    usd_parser/polygon_helper.cc)
endif()

if (TARGET UNIT_USDSensors_TEST)
  target_sources(UNIT_USDSensors_TEST PRIVATE
    usd_parser/USDSensors.cc)
endif()

if (TARGET UNIT_USDJoints_TEST)
  target_sources(UNIT_USDJoints_TEST PRIVATE
    usd_parser/USDJoints.cc)
endif()

if (TARGET UNIT_USDPhysics_TEST)
  target_sources(UNIT_USDPhysics_TEST PRIVATE
  usd_parser/USDPhysics.cc)
endif()

if (TARGET UNIT_USDTransport_TEST)
  target_sources(UNIT_USDTransport_TEST PRIVATE
  usd_parser/USDTransforms.cc)
endif()

if (TARGET UNIT_Conversions_TEST)
  target_sources(UNIT_Conversions_TEST PRIVATE
    Conversions.cc)
endif()

set(sdf2usd_test_sources
  Conversions.cc
  sdf_parser/Collision.cc
  sdf_parser/Geometry.cc
  sdf_parser/Joint.cc
  sdf_parser/Light.cc
  sdf_parser/Link.cc
  sdf_parser/Material.cc
  sdf_parser/Model.cc
  sdf_parser/Sensor.cc
  sdf_parser/Visual.cc
)

if (TARGET UNIT_Joint_Sdf2Usd_TEST)
  target_sources(UNIT_Joint_Sdf2Usd_TEST PRIVATE
    ${sdf2usd_test_sources})
endif()

if (TARGET UNIT_Light_Sdf2Usd_TEST)
  target_sources(UNIT_Light_Sdf2Usd_TEST PRIVATE
    ${sdf2usd_test_sources})
endif()

if (TARGET UNIT_Material_Sdf2Usd_TEST)
  target_sources(UNIT_Material_Sdf2Usd_TEST PRIVATE
    ${sdf2usd_test_sources})
endif()

add_subdirectory(cmd)

=== usd/include/sdf/CMakeLists.txt ===
ign_install_all_headers(COMPONENT usd)

=== usd/src/cmd/CMakeLists.txt ===
if(TARGET ${usd_target})
  add_executable(sdf2usd
    sdf2usd.cc
    ../sdf_parser/Collision.cc
    ../sdf_parser/Model.cc
    ../sdf_parser/Joint.cc
    ../sdf_parser/Link.cc
    ../sdf_parser/Geometry.cc
    ../sdf_parser/Material.cc
    ../sdf_parser/Sensor.cc
    ../sdf_parser/Visual.cc
    ../sdf_parser/Light.cc
    ../Conversions.cc
  )

  target_link_libraries(sdf2usd
    PUBLIC
      ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
      ignition-utils${IGN_UTILS_VER}::cli
      ${usd_target}
  )

  add_executable(usd2sdf
    usd2sdf.cc
  )

  target_link_libraries(usd2sdf
    PUBLIC
      ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
      ignition-utils${IGN_UTILS_VER}::cli
      ${usd_target}
  )

  install(
    TARGETS
    	sdf2usd
    	usd2sdf
    DESTINATION
    	${BIN_INSTALL_DIR}
  )
endif()

## sdformat12 12.3.0

=== debian/changelog ===
sdformat12 (12.3.0-1~buster) buster; urgency=medium

  * sdformat12 12.3.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Wed, 01 Dec 2021 15:30:21 -0700

sdformat12 (12.2.0-1~buster) buster; urgency=medium

  * sdformat12 12.2.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Tue, 23 Nov 2021 15:47:34 -0700

sdformat12 (12.1.0-1~buster) buster; urgency=medium

  * sdformat12 12.1.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Tue, 09 Nov 2021 14:15:14 -0700

sdformat12 (12.0.0-1~buster) buster; urgency=medium

  * sdformat12 12.0.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 30 Sep 2021 17:32:22 -0500

sdformat12 (12.0.0~pre2-1~buster) buster; urgency=medium

  * sdformat12 12.0.0~pre2-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Tue, 21 Sep 2021 22:23:19 -0500

sdformat12 (12.0.0~pre1-1~buster) buster; urgency=medium

  * sdformat12 12.0.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 20 Sep 2021 12:14:45 -0700

sdformat12 (11.999.999-1~buster) buster; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Thu, 01 Apr 2021 15:24:48 -0700

=== debian/control ===
Source: sdformat12
Standards-Version: 3.9.5
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               python,
               libtinyxml2-dev,
               doxygen,
               texlive-base,
               texlive-fonts-recommended,
               texlive-latex-extra,
               ruby,
               libignition-tools-dev,
               libignition-math6-dev,
               libignition-utils1-dev
Vcs-Browser: https://github.com/ignition-release/sdformat12-release
Vcs-Git: https://github.com/ignition-release/sdformat12-release
Homepage: http://sdformat.org

Package: libsdformat12
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends:  sdformat12-sdf (>= ${source:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
Multi-Arch: same
Breaks: libsdformat2,
        libsdformat3,
        libsdformat4,
        libsdformat5
Replaces: libsdformat2,
          libsdformat3,
          libsdformat4,
          libsdformat5
Description: Simulation Description Format (SDF) parser - Shared library
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: libsdformat12-dev
Architecture: any
Section: libdevel
Depends: libtinyxml2-dev,
         libignition-tools-dev,
         libignition-math6-dev,
         libignition-utils1-dev,
         libsdformat12 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libsdformat2-dev,
        libsdformat3-dev,
        libsdformat4-dev,
        libsdformat5-dev
Replaces: libsdformat2-dev,
        libsdformat3-dev,
        libsdformat4-dev,
        libsdformat5-dev
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Development files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: sdformat12-sdf
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Multi-Arch: foreign
Conflicts: libsdformat1
Description: Simulation Description Format (SDF) parser - SDF files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains SDF (Simulation Description Format) XML files needed by
 the libsdformat.

Package: libsdformat12-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
     libsdformat12 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Debugging symbols
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: sdformat12-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Multi-Arch: foreign
Description: Simulation Description Format (SDF) parser - Documentation
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains the program documentation

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

.PHONY: override_dh_auto_configure \
        override_dh_strip \
        override_dh_auto_test \
	override_dh_auto_build-indep


%:
	dh $@ --parallel

override_dh_auto_build-indep:
	dh_auto_build -- doc # Generate documentation.

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

# Tests are broken without a installed copy of sdformat.
# see: https://bitbucket.org/osrf/sdformat/issue/35
override_dh_auto_test:
	true

override_dh_strip:
	dh_strip -a --dbg-package=libsdformat12-dbg

## sdformat12 12.5.0

=== debian/changelog ===
sdformat12 (12.5.0-1~focal) focal; urgency=medium

  * sdformat12 12.5.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 13 May 2022 10:35:08 -0700

sdformat12 (12.4.0-1~focal) focal; urgency=medium

  * sdformat12 12.4.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Tue, 29 Mar 2022 18:23:00 -0700

sdformat12 (12.4.0~pre1-1~focal) focal; urgency=medium

  * sdformat12 12.4.0~pre1-1 release

 -- William Lew <williamlew@openrobotics.org>  Tue, 15 Mar 2022 18:22:03 +0000

sdformat12 (12.3.0-1~focal) focal; urgency=medium

  * sdformat12 12.3.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Wed, 01 Dec 2021 15:30:21 -0700

sdformat12 (12.2.0-1~focal) focal; urgency=medium

  * sdformat12 12.2.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Tue, 23 Nov 2021 15:47:34 -0700

sdformat12 (12.1.0-1~focal) focal; urgency=medium

  * sdformat12 12.1.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Tue, 09 Nov 2021 14:15:14 -0700

sdformat12 (12.0.0-1~focal) focal; urgency=medium

  * sdformat12 12.0.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 30 Sep 2021 17:32:22 -0500

sdformat12 (12.0.0~pre2-1~focal) focal; urgency=medium

  * sdformat12 12.0.0~pre2-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Tue, 21 Sep 2021 22:23:18 -0500

sdformat12 (12.0.0~pre1-1~focal) focal; urgency=medium

  * sdformat12 12.0.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 20 Sep 2021 12:14:45 -0700

sdformat12 (11.999.999-1~focal) focal; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Thu, 01 Apr 2021 15:24:48 -0700

## sdformat12 12.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
   CMAKE_POLICY(SET CMP0004 NEW)
 endif(COMMAND CMAKE_POLICY)
 
-project (sdformat12 VERSION 12.5.0)
+project (sdformat12 VERSION 12.7.2)
 
 # The protocol version has nothing to do with the package version.
 # It represents the current version of SDFormat implemented by the software
@@ -56,6 +56,9 @@
   #################################################
   # Find ign command line utility:
   find_program(IGN_PROGRAM ign)
+  # Note that CLI files are installed regardless of whether the dependency is
+  # available during build time
+  set(IGN_TOOLS_VER 1)
 
   #################################################
   # Copied from catkin/cmake/empy.cmake
@@ -101,26 +104,15 @@
   ########################################
   # Find ignition math
   # Set a variable for generating ProjectConfig.cmake
-  ign_find_package(ignition-math6 VERSION 6.8 REQUIRED)
+  ign_find_package(ignition-math6 VERSION 6.13 REQUIRED)
   set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})
 
   ########################################
   # Find ignition utils
   ign_find_package(ignition-utils1 VERSION REQUIRED)
-  ign_find_package(ignition-utils1 COMPONENTS cli REQUIRED_BY usd)
   set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})
 
-  ########################################
-  # Find ignition common
-  ign_find_package(ignition-common4 COMPONENTS graphics REQUIRED_BY usd)
-  set(IGN_COMMON_VER ${ignition-common4_VERSION_MAJOR})
-
-  ########################################
-  # Find PXR
-  ign_find_package(pxr QUIET REQUIRED_BY usd PKGCONFIG pxr)
-
-  ign_configure_build(HIDE_SYMBOLS_BY_DEFAULT QUIT_IF_BUILD_ERRORS
-    COMPONENTS usd)
+  ign_configure_build(HIDE_SYMBOLS_BY_DEFAULT QUIT_IF_BUILD_ERRORS)
 
   ign_create_packages()

=== conf/CMakeLists.txt ===
# Used only for internal testing.
set(ign_library_path "${CMAKE_BINARY_DIR}/test/lib/ruby/ignition/cmd${PROJECT_NAME}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: sdformat0.yaml
configure_file(
  "${PROJECT_NAME_NO_VERSION_LOWER}.yaml.in"
    "${CMAKE_BINARY_DIR}/test/conf/${PROJECT_NAME}.yaml" @ONLY)

# Used for the installed version.
set(ign_library_path "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmd${PROJECT_NAME}")

# Generate the configuration file that is installed.
# Note that the major version of the library is included in the name.
# Ex: sdformat0.yaml
configure_file(
  "${PROJECT_NAME_NO_VERSION_LOWER}.yaml.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.yaml
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

find_package(sdformat12 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")

include_directories(${SDFormat_INCLUDE_DIRS})
link_directories(${SDFormat_LIBRARY_DIRS})

add_executable(simple simple.cc)
target_link_libraries(simple ${SDFormat_LIBRARIES})

add_executable(dom dom.cc)
target_link_libraries(dom ${SDFormat_LIBRARIES})

=== include/CMakeLists.txt ===
add_subdirectory(sdf)

=== sdf/CMakeLists.txt ===
add_subdirectory(1.0)
add_subdirectory(1.2)
add_subdirectory(1.3)
add_subdirectory(1.4)
add_subdirectory(1.5)
add_subdirectory(1.6)
add_subdirectory(1.7)
add_subdirectory(1.8)
add_subdirectory(1.9)

add_custom_target(schema)
add_dependencies(schema schema1_9)

# Generate the EmbeddedSdf.cc file, which contains all the supported SDF
# descriptions in a map of strings. The parser.cc file uses EmbeddedSdf.hh.
execute_process(
  COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/sdf/embedSdf.rb
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/sdf"
  OUTPUT_FILE "${PROJECT_BINARY_DIR}/src/EmbeddedSdf.cc"
)

# Generate aggregated SDF description files for use by the sdformat.org 
# website. If the description files change, the generated full*.sdf files need 
# to be removed before running this target.
if (IGN_PROGRAM)

  # Update this list as new sdformat spec versions are added.
  set(sdf_desc_versions 1.4 1.5 1.6 1.7 1.8 1.9)

  set(description_targets)
  foreach(desc_ver ${sdf_desc_versions})
    string(REPLACE "." "-" desc_ver_dash ${desc_ver})
    list(APPEND description_targets ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMAND
        ${CMAKE_COMMAND} -E env IGN_CONFIG_PATH=${CMAKE_BINARY_DIR}/test/conf
        ${IGN_PROGRAM}
      ARGS sdf -d ${desc_ver} > ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMENT "Generating full description for spec ${desc_ver}"
      VERBATIM)
  endforeach()
  add_custom_target(sdf_descriptions DEPENDS ${description_targets} ${PROJECT_LIBRARY_TARGET_NAME})
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -121,9 +121,6 @@
 endif()
 
 target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
-  PUBLIC
-    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
-    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}/..>
   PRIVATE
     ${CMAKE_CURRENT_SOURCE_DIR}
 )

=== test/CMakeLists.txt ===
get_filename_component(IGN_PATH ${IGN_PROGRAM} DIRECTORY)
configure_file(test_config.h.in ${PROJECT_BINARY_DIR}/include/test_config.h)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
target_include_directories(gtest
  PUBLIC
    ${PROJECT_SOURCE_DIR}/test/gtest/include
    ${PROJECT_SOURCE_DIR}/test/gtest
)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)

add_subdirectory(integration)
add_subdirectory(performance)

=== include/sdf/CMakeLists.txt ===
# Exlcude some files so that they are not added to the master header.
ign_install_all_headers(EXCLUDE_FILES sdf.hh sdf_config.h)
install(
  FILES
    sdf.hh
    sdf_config.h
  DESTINATION ${IGN_INCLUDE_INSTALL_DIR_FULL}/${PROJECT_INCLUDE_DIR}
)

=== sdf/1.0/CMakeLists.txt ===
set (sdfs
  actor.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  gazebo.sdf
  geometry.sdf
  gripper.sdf
  gui.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  link.sdf
  model.sdf
  physics.sdf
  plugin.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  scene.sdf
  sensor.sdf
  state.sdf
  surface.sdf
  visual.sdf
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.0/)

=== sdf/1.5/CMakeLists.txt ===
set (sdfs
  actor.sdf
  altimeter.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_5 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_4.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.5)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.5)

=== sdf/1.6/CMakeLists.txt ===
set (sdfs
  actor.sdf
  air_pressure.sdf
  altimeter.sdf
  atmosphere.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  lidar.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  particle_emitter.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_6 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_5.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.6)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.6)

=== sdf/1.7/CMakeLists.txt ===
set (sdfs
  actor.sdf
  air_pressure.sdf
  altimeter.sdf
  atmosphere.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  lidar.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  particle_emitter.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_7 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_6.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.7)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${PROJECT_VERSION_MAJOR}/1.7)

=== debian/changelog ===
sdformat12 (12.7.2-1~focal) focal; urgency=medium

  * sdformat12 12.7.2-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Fri, 01 Sep 2023 15:47:45 -0500

sdformat12 (12.7.1-1~focal) focal; urgency=medium

  * sdformat12 12.7.1-1 release

 -- Ian Chen <ichen@openrobotics.org>  Tue, 28 Feb 2023 14:29:12 -0800

sdformat12 (12.7.0-1~focal) focal; urgency=medium

  * sdformat12 12.7.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Mon, 06 Feb 2023 08:36:22 -0800

sdformat12 (12.7.0~pre1-1~focal) focal; urgency=medium

  * sdformat12 12.7.0~pre1-1 release

 -- Nate Koenig <nate@openrobotics.org>  Fri, 03 Feb 2023 14:52:12 -0800

sdformat12 (12.6.0-2~focal) focal; urgency=medium

  * sdformat12 12.6.0-2 release

 -- Steve Peters <scpeters@openrobotics.org>  Fri, 30 Sep 2022 13:52:08 -0700

sdformat12 (12.6.0-1~focal) focal; urgency=medium

  * sdformat12 12.6.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Tue, 27 Sep 2022 04:39:40 -0700

sdformat12 (12.6.0~pre1-1~focal) focal; urgency=medium

  * sdformat12 12.6.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Wed, 07 Sep 2022 14:33:22 -0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 9),
-               python,
+               python3,
                libtinyxml2-dev,
                doxygen,
                texlive-base,

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure \
        override_dh_strip \
        override_dh_auto_test

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DSKIP_usd=true \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_after_dh_auto_build-indep:
	dh_auto_build -- doc  # Generate documentation

override_dh_auto_test-arch:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src LC_ALL=C dh_auto_test

override_dh_strip:
	dh_strip -a --dbg-package=libsdformat12-dbg
